# -*- coding: utf-8 -*-
#
# Author: Rodney Dawes <rodney.dawes@canonical.com>
#
# Copyright 2010 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.
""" Tests for the ubuntuone-preferences control panel app."""

import new
import os

from contrib.testing.testcase import DBusTwistedTestCase

class InvalidSignalError(Exception):
    """Exception for when we get the wrong signal called."""
    pass

class PreferencesTests(DBusTwistedTestCase):
    """Basic tests for the ubuntuone-preferences app."""

    _path = os.path.join(os.getcwd(), "bin", "ubuntuone-preferences")
    u1prefs = new.module('u1prefs')
    execfile(_path, u1prefs.__dict__)

    def setUp(self):
        DBusTwistedTestCase.setUp(self)

    def tearDown(self):
        # collect all signal receivers registered during the test
        signal_receivers = set()
        with self.bus._signals_lock:
            for group in self.bus._signal_recipients_by_object_path.values():
                for matches in group.values():
                    for match in matches.values():
                        signal_receivers.update(match)
        d = self.cleanup_signal_receivers(signal_receivers)
        d.addBoth(lambda _: DBusTwistedTestCase.tearDown(self))
        return d

    def test_create_dialog(self):
        """ Test that denying authorization works correctly. """

        dialog = self.u1prefs.UbuntuOneDialog()
        self.assertTrue(dialog is not None)

